SystemOrganization addCategory: #'DripfeedIt-Domain'!

Object subclass: #DFIDay
	instanceVariableNames: 'date meals'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DripfeedIt-Domain'!

!DFIDay class methodsFor: 'instance creation' stamp: 'PhilippeBack 6/1/2013 23:35'!
create: aDate 
	^self new
		date: aDate;
		yourself ! !

!DFIDay methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/2/2013 00:03'!
addMeal: aMeal 
	self meals add: aMeal.
    ^aMeal! !

!DFIDay methodsFor: 'accessing' stamp: 'PhilippeBack 6/1/2013 23:24'!
date
	^ date! !

!DFIDay methodsFor: 'accessing' stamp: 'PhilippeBack 6/1/2013 23:25'!
date: aDate
	
	date := aDate! !

!DFIDay methodsFor: 'accessing' stamp: 'PhilippeBack 6/1/2013 23:42'!
meals
  ^meals ifNil: [ meals := OrderedCollection new  ]! !

Object subclass: #DFIFood
	instanceVariableNames: 'name'
	classVariableNames: 'Nutrients'
	poolDictionaries: ''
	category: 'DripfeedIt-Domain'!

!DFIFood class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/2/2013 00:30'!
loadNutrientsInformation

   self flag: #TODO.
   "Load nutrients from CSV"
   "food -> nutrient -> ajr;ajo"
	
! !

!DFIFood class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/1/2013 23:53'!
named: aString
   self flag: #TODO.
   "I'd like to be able to do something like a smart matching"
    ^self new name: aString; yourself

   
! !

!DFIFood class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/2/2013 00:29'!
nutrients
  ^ Nutrients ifNil: [  
		Nutrients := Dictionary new.
		self loadNutrientsInformation.
		Nutrients.
      ] 

   
! !

!DFIFood methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/2/2013 00:12'!
name
  ^name! !

!DFIFood methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/1/2013 23:54'!
name: aString
   name := aString ! !

!DFIFood methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/2/2013 00:25'!
nutrients
	! !

Object subclass: #DFIMeal
	instanceVariableNames: 'hour minutes composition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DripfeedIt-Domain'!

!DFIMeal class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/1/2013 23:37'!
hour: anHour minutes: aMinutes
   ^self new
		hour: anHour;
		minutes: aMinutes;
		yourself! !

!DFIMeal methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/4/2013 23:02'!
composedOf: aQuantityInGrams gramsOf: aFood 

   self flag: #Replaces.
  "Add a meal detaul in the composition, stop making it a dictionary"
   self composition add: (DFIMealDetail food: aFood quantity: aQuantityInGrams)! !

!DFIMeal methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/4/2013 23:26'!
composition
   ^composition ifNil: [ composition := OrderedCollection new ].! !

!DFIMeal methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/4/2013 23:00'!
contains: aFoodName
	composition do: [ :mealDetail |
		(mealDetail contains: aFoodName) ifTrue: [ 
			^true 
		]
	].
	^false! !

!DFIMeal methodsFor: 'accessing' stamp: 'PhilippeBack 6/1/2013 23:37'!
hour
	
	^ hour! !

!DFIMeal methodsFor: 'accessing' stamp: 'PhilippeBack 6/1/2013 23:37'!
hour: anObject
	
	hour := anObject! !

!DFIMeal methodsFor: 'accessing' stamp: 'PhilippeBack 6/1/2013 23:37'!
minutes
	
	^ minutes! !

!DFIMeal methodsFor: 'accessing' stamp: 'PhilippeBack 6/1/2013 23:37'!
minutes: anObject
	
	minutes := anObject! !

!DFIMeal methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/2/2013 00:24'!
nutrients
     self flag: #TOCHECK.
	composition collect: [ :each | each nutrients ]! !

!DFIMeal methodsFor: 'accessing' stamp: 'PhilippeBack 6/4/2013 23:10'!
weight
	| sum |
	sum := 0.
	self composition do: [ :each | sum := sum + each quantity ].
	^sum! !

Object subclass: #DFIMealDetail
	instanceVariableNames: 'quantity food'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DripfeedIt-Domain'!

!DFIMealDetail class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/4/2013 23:01'!
food: aFood quantity: aQuantity
   ^self new
		food: aFood;
		quantity: aQuantity;
		yourself! !

!DFIMealDetail methodsFor: 'accessing' stamp: 'PhilippeBack 6/4/2013 23:06'!
contains: aFoodName
	^(self food name = aFoodName)! !

!DFIMealDetail methodsFor: 'accessing' stamp: 'PhilippeBack 6/4/2013 11:26'!
food
	
	^ food! !

!DFIMealDetail methodsFor: 'accessing' stamp: 'PhilippeBack 6/4/2013 11:26'!
food: anObject
	
	food := anObject! !

!DFIMealDetail methodsFor: 'accessing' stamp: 'PhilippeBack 6/4/2013 11:26'!
quantity
	
	^ quantity! !

!DFIMealDetail methodsFor: 'accessing' stamp: 'PhilippeBack 6/4/2013 11:26'!
quantity: anObject
	
	quantity := anObject! !

Object subclass: #DFINutrient
	instanceVariableNames: 'nutrient ajr ajo usage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DripfeedIt-Domain'!

DFINutrient class
	instanceVariableNames: 'items'!

DFINutrient class
	instanceVariableNames: 'items'!

!DFINutrient class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/22/2013 14:28'!
add: anItem 
	self all add: anItem ! !

!DFINutrient class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/22/2013 14:38'!
all
   ^items ifNil: [  items := self demoNutrients "OrderedCollection new" ]! !

!DFINutrient class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/22/2013 14:37'!
demoNutrients
	^OrderedCollection new
		add: ( DFINutrient new
				nutrient: 'Calcium';
				ajr: 40;
				yourself);
		yourself! !

!DFINutrient class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/22/2013 14:27'!
reset
	items := nil! !

!DFINutrient methodsFor: 'accessing' stamp: 'PhilippeBack 6/22/2013 14:22'!
ajo
	^ ajo! !

!DFINutrient methodsFor: 'accessing' stamp: 'PhilippeBack 6/22/2013 14:22'!
ajo: anObject
	ajo := anObject! !

!DFINutrient methodsFor: 'accessing' stamp: 'PhilippeBack 6/22/2013 14:22'!
ajr
	^ ajr! !

!DFINutrient methodsFor: 'accessing' stamp: 'PhilippeBack 6/22/2013 14:22'!
ajr: anObject
	ajr := anObject! !

!DFINutrient methodsFor: 'descriptions' stamp: 'PhilippeBack 6/22/2013 15:30'!
descriptionAjo
	<magritteDescription>
	^MANumberDescription new
		priority: 30;
		label: 'AJO';
		tooltip: 'Apport Journalier Optimal';
		accessor: #ajo;
		beRequired;
		addCondition: [ :value | value > 0 ] labelled: 'L''AJO doit tre positif';
		yourself
		! !

!DFINutrient methodsFor: 'descriptions' stamp: 'PhilippeBack 6/22/2013 14:35'!
descriptionAjr
	<magritteDescription>
	^MANumberDescription new
		priority: 20;
		label: 'AJR';
		tooltip: 'Apport Journalier Recommand';
		accessor: #ajr;
		beRequired;
		addCondition: [ :value | value > 0 ] labelled: 'L''AJR doit tre positif';
		yourself
		! !

!DFINutrient methodsFor: 'descriptions' stamp: 'PhilippeBack 6/22/2013 14:31'!
descriptionNutrient
	<magritteDescription>
	^MAStringDescription new
		priority: 10;
		label: 'Nom';
		tooltip: 'Nom du nutriment';
		accessor: #nutrient;
		beRequired;
		yourself
		! !

!DFINutrient methodsFor: 'descriptions' stamp: 'PhilippeBack 6/22/2013 15:31'!
descriptionUsage
	<magritteDescription>
	^MAMemoDescription new
		priority: 50;
		label: 'Utilisation';
		tooltip: 'Utilisation du nutriment';
		accessor: #usage;
		beRequired;
		yourself
		! !

!DFINutrient methodsFor: 'accessing' stamp: 'PhilippeBack 6/22/2013 14:22'!
nutrient
	^ nutrient! !

!DFINutrient methodsFor: 'accessing' stamp: 'PhilippeBack 6/22/2013 14:22'!
nutrient: anObject
	nutrient := anObject! !

!DFINutrient methodsFor: 'accessing' stamp: 'PhilippeBack 6/1/2013 21:40'!
title
	
	^ title! !

!DFINutrient methodsFor: 'accessing' stamp: 'PhilippeBack 6/1/2013 21:40'!
title: anObject
	
	title := anObject! !

!DFINutrient methodsFor: 'accessing' stamp: 'PhilippeBack 6/22/2013 14:22'!
usage
	^ usage! !

!DFINutrient methodsFor: 'accessing' stamp: 'PhilippeBack 6/22/2013 14:22'!
usage: anObject
	usage := anObject! !

Object subclass: #DFINutrients
	instanceVariableNames: 'title items'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'DripfeedIt-Domain'!

!DFINutrients class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/1/2013 21:40'!
default
  ^ Default ifNil: [  Default := self new ] ! !

!DFINutrients class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/1/2013 21:40'!
default: someVitamins
  Default := someVitamins 
! !

!DFINutrients class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/1/2013 21:40'!
initializeExamples
    "self initializeExamples"
	self default 
		title: 'DripfeedIt UML Stories';
		add: (DFIStory new 
					title: 'The Use Case Model');
		add: (DFIStory new
					title: 'The Domain Model');
		add: (DFIStory new
					title: 'The Stakeholder Requirements Model')
! !

!DFINutrients class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/1/2013 21:40'!
reset
	Default := nil! !

!DFINutrients methodsFor: 'accessing' stamp: 'PhilippeBack 6/1/2013 21:40'!
add: anItem
	self items add: anItem! !

!DFINutrients methodsFor: 'accessing' stamp: 'PhilippeBack 6/1/2013 21:40'!
initialize
	self items: OrderedCollection new! !

!DFINutrients methodsFor: 'accessing' stamp: 'PhilippeBack 6/1/2013 21:40'!
items
	
	^ items! !

!DFINutrients methodsFor: 'accessing' stamp: 'PhilippeBack 6/1/2013 21:40'!
items: anObject
	
	items := anObject! !

!DFINutrients methodsFor: 'accessing' stamp: 'PhilippeBack 6/1/2013 21:40'!
remove: anItem
	^ self items remove: anItem! !

!DFINutrients methodsFor: 'accessing' stamp: 'PhilippeBack 6/1/2013 21:40'!
title
	
	^ title! !

!DFINutrients methodsFor: 'accessing' stamp: 'PhilippeBack 6/1/2013 21:40'!
title: anObject
	
	title := anObject! !

Object subclass: #DFIStories
	instanceVariableNames: 'title items'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'DripfeedIt-Domain'!

!DFIStories class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 5/23/2013 09:25'!
default
  ^ Default ifNil: [  Default := self new ] ! !

!DFIStories class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 5/23/2013 09:16'!
default: someStories
  Default := someStories! !

!DFIStories class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 5/23/2013 09:34'!
initializeExamples
    "self initializeExamples"
	self default 
		title: 'DripfeedIt UML Stories';
		add: (DFIStory new 
					title: 'The Use Case Model');
		add: (DFIStory new
					title: 'The Domain Model');
		add: (DFIStory new
					title: 'The Stakeholder Requirements Model')
! !

!DFIStories class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 5/23/2013 09:28'!
reset
	Default := nil! !

!DFIStories methodsFor: 'accessing' stamp: 'PhilippeBack 5/23/2013 09:26'!
add: anItem
	self items add: anItem! !

!DFIStories methodsFor: 'accessing' stamp: 'PhilippeBack 5/23/2013 09:26'!
initialize
	self items: OrderedCollection new! !

!DFIStories methodsFor: 'accessing' stamp: 'PhilippeBack 5/23/2013 09:26'!
items
	
	^ items! !

!DFIStories methodsFor: 'accessing' stamp: 'PhilippeBack 5/23/2013 09:26'!
items: anObject
	
	items := anObject! !

!DFIStories methodsFor: 'accessing' stamp: 'PhilippeBack 5/23/2013 09:26'!
remove: anItem
	^ self items remove: anItem! !

!DFIStories methodsFor: 'accessing' stamp: 'PhilippeBack 5/23/2013 09:26'!
title
	
	^ title! !

!DFIStories methodsFor: 'accessing' stamp: 'PhilippeBack 5/23/2013 09:26'!
title: anObject
	
	title := anObject! !

Object subclass: #DFIStory
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DripfeedIt-Domain'!

!DFIStory commentStamp: '<historical>' prior: 0!
Food is just linked to nutrients (Food is a description)
!

!DFIStory methodsFor: 'accessing' stamp: 'PhilippeBack 5/23/2013 09:29'!
title
	
	^ title! !

!DFIStory methodsFor: 'accessing' stamp: 'PhilippeBack 5/23/2013 09:29'!
title: anObject
	
	title := anObject! !

Object subclass: #DFIUser
	instanceVariableNames: 'userid username registered days'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DripfeedIt-Domain'!

!DFIUser class methodsFor: 'instance creation' stamp: 'PhilippeBack 6/3/2013 23:51'!
userid: userid username: username

	^ self new
		userid: userid;
		username: username;
		registered: DateAndTime now;
		yourself! !

!DFIUser methodsFor: 'accessing' stamp: 'PhilippeBack 6/4/2013 00:11'!
addDay: aDay 
	self days add: aDay.
    ^aDay ! !

!DFIUser methodsFor: 'accessing' stamp: 'PhilippeBack 6/4/2013 00:12'!
days
  ^days ifNil: [ days := OrderedCollection new  ]! !

!DFIUser methodsFor: 'accessing' stamp: 'PhilippeBack 6/3/2013 23:49'!
registered
	
	^ registered! !

!DFIUser methodsFor: 'accessing' stamp: 'PhilippeBack 6/3/2013 23:49'!
registered: anObject
	
	registered := anObject! !

!DFIUser methodsFor: 'accessing' stamp: 'PhilippeBack 6/3/2013 23:49'!
userid
	
	^ userid! !

!DFIUser methodsFor: 'accessing' stamp: 'PhilippeBack 6/3/2013 23:49'!
userid: anObject
	
	userid := anObject! !

!DFIUser methodsFor: 'accessing' stamp: 'PhilippeBack 6/3/2013 23:49'!
username
	
	^ username! !

!DFIUser methodsFor: 'accessing' stamp: 'PhilippeBack 6/3/2013 23:49'!
username: anObject
	
	username := anObject! !

Object subclass: #DFIUsers
	instanceVariableNames: 'title items'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'DripfeedIt-Domain'!

!DFIUsers commentStamp: '<historical>' prior: 0!
DFIUsers default explore
DFIUsers reset.
DFIUsers initializeExamples.
DFIEatWellFileDatabase saveRepository.!

!DFIUsers class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/3/2013 23:43'!
default
  ^ Default ifNil: [  Default := self new ] ! !

!DFIUsers class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/3/2013 23:44'!
default: someUsers
  Default := someUsers! !

!DFIUsers class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/4/2013 00:00'!
initializeExamples
    "self reset"
    "self initializeExamples"
	self default 
		title: 'DFI Eat Well Users';
		add: (DFIUser userid: 'pbk' username: 'Philippe Back');
		add: (DFIUser userid: 'cath' username: 'Catherine Absil');
		add: (DFIUser userid: 'admin' username: 'System Administrator').! !

!DFIUsers class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/3/2013 23:51'!
reset
     "self reset"
	Default := nil! !

!DFIUsers methodsFor: 'accessing' stamp: 'PhilippeBack 6/3/2013 23:43'!
add: anItem
	self items add: anItem! !

!DFIUsers methodsFor: 'accessing' stamp: 'PhilippeBack 6/3/2013 23:43'!
initialize
	self items: OrderedCollection new! !

!DFIUsers methodsFor: 'accessing' stamp: 'PhilippeBack 6/3/2013 23:43'!
items
	
	^ items! !

!DFIUsers methodsFor: 'accessing' stamp: 'PhilippeBack 6/3/2013 23:43'!
items: anObject
	
	items := anObject! !

!DFIUsers methodsFor: 'accessing' stamp: 'PhilippeBack 6/3/2013 23:43'!
remove: anItem
	^ self items remove: anItem! !

!DFIUsers methodsFor: 'accessing' stamp: 'PhilippeBack 6/3/2013 23:43'!
title
	
	^ title! !

!DFIUsers methodsFor: 'accessing' stamp: 'PhilippeBack 6/3/2013 23:43'!
title: anObject
	
	title := anObject! !
